from ngsolve import *
from netgen.geom2d import unit_square
import pickle

restart = False

if restart:
    # Get mesh from pickled GridFunction
    unpickler = pickle.Unpickler(open("restart_file.data", "rb"))
    _gfu_pic, = unpickler.load()
    mesh = Mesh(_gfu_pic.space.mesh.ngmesh.Copy())
    file_out = "file_again.data"
else:
    # Create new mesh
    mesh = Mesh(unit_square.GenerateMesh(maxh=0.01))
    file_out = "restart_file.data"

V = H1(mesh, order=1)
gfu = GridFunction(V)

if restart:
    # Copy Data
    gfu.vec.data = _gfu_pic.vec
    
    # Clean-up
    del _gfu_pic, unpickler
else: 
    gfu.Set(1, definedon=mesh.Boundaries("left"))

Draw(gfu, mesh, "vel")

pickler = pickle.Pickler(open(file_out, "wb"))
data = [gfu]

print("before dump")
pickler.dump(data)
print("after dump")